# -*- coding: utf-8 -*-
from __future__ import unicode_literals, division, absolute_import, print_function
__license__   = 'GPL v3'
__copyright__ = '2014,2015,2016,2017,2018,2019,2020 DaltonST <DaltonShiTzu@outlook.com>'
__my_version__ = "3.6.106"    # Technical changes after Python 3.8 testing with Calibre 4.99.4

# ---------------------------------------------------------------------------------------
# Common keywords in Work Title, Work Series, Work Author to Remove
# ---------------------------------------------------------------------------------------
from polyglot.builtins import as_unicode

def remove_bad_keywords(s_string):

    s_string = as_unicode(s_string)  #always pure unicode, even in python2

    #---------------
    s_string = s_string.replace("  ", " ").strip()
    #---------------
    if s_string.startswith("Microsoft Word -"):
        s_string = s_string.replace("Microsoft Word -", "")
    s_string = s_string.replace("Microsoft Word", "")
    s_string = s_string.strip()
    if s_string.startswith("-"):
        s_string = s_string[1: ]
    s_string = s_string.strip()
    if s_string.endswith(" La") or s_string.endswith(" la"):
        s_string = s_string[0:-3]  #residual artifact from Novella
    if s_string.endswith(" Mystery Series)"):
        s_string = s_string.replace(" Mystery Series)", " )")
     #---------------
    s_string = s_string.replace("  ", " ")
    s_string = s_string.strip()
    #---------------
    s_string = s_string.replace("_", "")
    s_string = s_string.replace("--- Scanned by Number 4 ---", "")
    s_string = s_string.replace("--- Scanned by Number 5 ---", "")
    s_string = s_string.replace("--- Scanned by Number 6 ---", "")
    s_string = s_string.replace(": A New Adult Romance", "")
    s_string = s_string.replace(".doc", "")
    s_string = s_string.replace(".DOC", "")
    s_string = s_string.replace(".docx", "")
    s_string = s_string.replace(".indd", "")
    s_string = s_string.replace(".INDD", "")
    s_string = s_string.replace(".jpg", "")
    s_string = s_string.replace(".pdf", "")
    s_string = s_string.replace(".PDF", "")
    s_string = s_string.replace(".png", "")
    s_string = s_string.replace(".rar", "")
    s_string = s_string.replace(".txt", "")
    s_string = s_string.replace(".Txt", "")
    s_string = s_string.replace(".zip", "")

    s_string = s_string.replace(" Edited by", "")
    s_string = s_string.replace("(ebook by Undead)", "")
    s_string = s_string.replace("New Title 1", "")

    s_string = s_string.replace("(.v1.0.).", "")  #caused by Quality Check plugin when fixing initials for authors
    s_string = s_string.replace("(ARC)", "")
    s_string = s_string.replace("(Book One in the ", "(Book #1:  ")      #causes index to be set properly...
    s_string = s_string.replace("(Book Two in the ", "( Book #2: ")
    s_string = s_string.replace("(Book Three in the ", "( Book #3: ")
    s_string = s_string.replace("(Book Four in the ", "( Book #4: ")
    s_string = s_string.replace("(Book Sets for Kids: Grade 3 and Up)", "")
    s_string = s_string.replace("(Book Sets for Kids: Grade 4 and Up)", "")
    s_string = s_string.replace("(Book Sets for Kids: Grade 5 and Up)", "")
    s_string = s_string.replace("(c.1)", "")  #Problem:  stripping utf8 characters also removes the ( and )...
    s_string = s_string.replace("(c.2)", "")
    s_string = s_string.replace("(c.3)", "")
    s_string = s_string.replace("(c.4)", "")
    s_string = s_string.replace("(c.5)", "")
    s_string = s_string.replace("(c.6)", "")
    s_string = s_string.replace("(epub)", "")
    s_string = s_string.replace("(mobi)", "")
    s_string = s_string.replace("(New Deluxe Edition)", "")
    s_string = s_string.replace("(REVIEW)", "")
    s_string = s_string.replace("(v.1)", "")
    s_string = s_string.replace("(v.2)", "")
    s_string = s_string.replace("(v.3)", "")
    s_string = s_string.replace("(v.4)", "")
    s_string = s_string.replace("(v.5)", "")
    s_string = s_string.replace("(v.6)", "")
    s_string = s_string.replace("(v1.0)", "")
    s_string = s_string.replace("(v2.0)", "")
    s_string = s_string.replace("(v3.0)", "")
    s_string = s_string.replace("(v4.0)", "")
    s_string = s_string.replace("(v5.0)", "")
    s_string = s_string.replace("(v6.0)", "")
    s_string = s_string.replace("(Valancourt Classics)", "")
    s_string = s_string.replace("a Paranormal Romance", "")
    s_string = s_string.replace("admin", "_Unknown_")
    s_string = s_string.replace("Admin", "_Unknown_")
    s_string = s_string.replace("ARC: ", "")
    s_string = s_string.replace("BBW Paranormal Romance", "")
    s_string = s_string.replace("BBW Paranormal Werewolf Shifter Romance", "")
    s_string = s_string.replace("Billionaire Domination / Erotic Romance", "")
    s_string = s_string.replace("Billionaire Romance / Romantic Suspense", "")
    s_string = s_string.replace("BookZZ.org", "")
    s_string = s_string.replace("Bookzz.org", "")
    s_string = s_string.replace("bookzz.org", "")
    s_string = s_string.replace("c.1", "")
    s_string = s_string.replace("c.2", "")
    s_string = s_string.replace("c.3", "")
    s_string = s_string.replace("c.4", "")
    s_string = s_string.replace("c.5", "")
    s_string = s_string.replace("c.6", "")
    s_string = s_string.replace("ebook", "")
    s_string = s_string.replace("epub", "")
    s_string = s_string.replace("from Nexus Magazine", "")
    s_string = s_string.replace("Historical Romance", "")
    s_string = s_string.replace("Important ! Readme", "")
    s_string = s_string.replace("Important!", "")
    s_string = s_string.replace("int.indd", "")
    s_string = s_string.replace("INT.INDD", "")
    s_string = s_string.replace("Layout 1", "")
    s_string = s_string.replace("Layout 2", "")
    s_string = s_string.replace("Microsoft Office Word Document", "")
    s_string = s_string.replace("Microsoft Office", "")
    s_string = s_string.replace("Microsoft Word - ", "")
    s_string = s_string.replace("Microsoft Word - New Microsoft Office Word Document", "")
    s_string = s_string.replace("mobi", "")
    s_string = s_string.replace("Motorcycle Club Menage Erotica", "")
    s_string = s_string.replace("New Deluxe Edition", "")
    s_string = s_string.replace("New Microsoft Office Word Document", "")
    s_string = s_string.replace("Penguin Metro Reads", "")
    s_string = s_string.replace("Mystery Mystery", "Mystery")
    s_string = s_string.replace("Mystery mystery", "Mystery")

    #---------------------------------
    s_string = s_string.replace("R1.0", "")
    s_string = s_string.replace("r1.0", "")
    s_string = s_string.replace("R2.0", "")
    s_string = s_string.replace("r2.0", "")
    s_string = s_string.replace("R3.0", "")
    s_string = s_string.replace("r3.0", "")
    s_string = s_string.replace("R4.0", "")
    s_string = s_string.replace("r4.0", "")
    s_string = s_string.replace("R5.0", "")
    s_string = s_string.replace("r5.0", "")
    s_string = s_string.replace("R6.0", "")
    s_string = s_string.replace("r6.0", "")
    s_string = s_string.replace("R1.", "")
    s_string = s_string.replace("r1.", "")
    s_string = s_string.replace("R2.", "")
    s_string = s_string.replace("r2.", "")
    s_string = s_string.replace("R3.", "")
    s_string = s_string.replace("r3.", "")
    s_string = s_string.replace("R4.", "")
    s_string = s_string.replace("r4.", "")
    s_string = s_string.replace("R5.", "")
    s_string = s_string.replace("r5.", "")
    s_string = s_string.replace("R6.", "")
    s_string = s_string.replace("r6.", "")
    #-----------------------------------

    s_string = s_string.replace("Readme", "")

    s_string = s_string.replace("-Anthology", "")
    s_string = s_string.replace("[Anthology]", "")
    s_string = s_string.replace("Anthology", "")
    s_string = s_string.replace(".wps", "")
    s_string = s_string.replace("(Kindle Single)", "")
    s_string = s_string.replace("Kindle Single", "")
    s_string = s_string.replace("(Complete & Uncut)", "")
    s_string = s_string.replace("Complete & Uncut", "")

    s_string = s_string.replace("Small Press Distribution (All Titles)", "")
    s_string = s_string.replace("Small Press Distribution (All titles)", "")
    s_string = s_string.replace("Small Press Distribution", "")
    s_string = s_string.replace("Barnes & Noble Classics Series", "")
    s_string = s_string.replace("(Unabridged Penguin)", "")
    s_string = s_string.replace("Sweet Historical Mail Order Bride Romance", "")
    s_string = s_string.replace("Sweet, Clean Western Historical Romance", "")
    s_string = s_string.replace("Taboo Bareback Romance Novella", "")
    s_string = s_string.replace("Thorndike Press Large Print Basic Series", "")
    s_string = s_string.replace("Torrent downloaded from Demonoid.me", "")
    s_string = s_string.replace("Torrent downloaded from demonoid.ph", "")
    s_string = s_string.replace("Torrent downloaded from Demonoid", "")
    s_string = s_string.replace("Untitled Document", "_Unknown_")
    s_string = s_string.replace("v1.0", "")
    s_string = s_string.replace("v2.0", "")
    s_string = s_string.replace("v3.0", "")
    s_string = s_string.replace("v4.0", "")
    s_string = s_string.replace("v5.0", "")
    s_string = s_string.replace("v6.0", "")
    s_string = s_string.replace("v.1", "")
    s_string = s_string.replace("v.2", "")
    s_string = s_string.replace("v.3", "")
    s_string = s_string.replace("v.4", "")
    s_string = s_string.replace("v.5", "")
    s_string = s_string.replace("v.6", "")
    s_string = s_string.replace("V1.0", "")
    s_string = s_string.replace("V2.0", "")
    s_string = s_string.replace("V3.0", "")
    s_string = s_string.replace("V4.0", "")
    s_string = s_string.replace("V5.0", "")
    s_string = s_string.replace("V6.0", "")
    s_string = s_string.replace("V.1", "")
    s_string = s_string.replace("V.2", "")
    s_string = s_string.replace("V.3", "")
    s_string = s_string.replace("V.4", "")
    s_string = s_string.replace("V.5", "")
    s_string = s_string.replace("V.6", "")
    s_string = s_string.replace("Valancourt Classics", "")
    s_string = s_string.replace("Vintage Contemporaries", "")
    s_string = s_string.replace("Werebear/BBW Paranormal Romance", "")
    s_string = s_string.replace("Word Document", "")
    s_string = s_string.replace("- 1.doc", "")  #the dash causes confusion and is garbage in this context
    s_string = s_string.replace("- 1.docx", "")
    s_string = s_string.replace("- 1.pdf", "")
    s_string = s_string.replace("- 1.txt", "")
    s_string = s_string.replace("- Microsoft Word -", "")
    s_string = s_string.replace("-Microsoft Word-", "")
    s_string = s_string.replace(": A Christmas Novel", "")
    s_string = s_string.replace(": A Contemporary Romance Novel", "")
    s_string = s_string.replace(": A Mystery", "")  #residual artifact
    s_string = s_string.replace(": a Mystery", "")  #residual artifact
    s_string = s_string.replace(": A New Adult Romance", "")
    s_string = s_string.replace(": A Novel of Suspense", "")
    s_string = s_string.replace(": A Novel", "")  #residual artifact
    s_string = s_string.replace(": a Novel", "")  #residual artifact
    s_string = s_string.replace(": A Novella", "")  #residual artifact
    s_string = s_string.replace(": a Novella", "")  #residual artifact
    s_string = s_string.replace(": An Thriller", "")  #residual artifact
    s_string = s_string.replace(": an Thriller", "")  #residual artifact
    s_string = s_string.replace(".docx", "")
    s_string = s_string.replace(".DOCX", "")
    s_string = s_string.replace(".doc", "")
    s_string = s_string.replace(".DOC", "")
    s_string = s_string.replace(".pdf", "")
    s_string = s_string.replace(".PDF", "")
    s_string = s_string.replace(".rtf", "")
    s_string = s_string.replace(".RTF", "")
    s_string = s_string.replace("(ARC)", "")
    s_string = s_string.replace("(BBW Paranormal Shape Shifter Romance)", "")
    s_string = s_string.replace("(BDSM Erotic Romance)", "")
    s_string = s_string.replace("(BDSM)", "")
    s_string = s_string.replace("(Contemporary Romance)", "")
    s_string = s_string.replace("(Fantasy, Paranormal, Romance)", "")
    s_string = s_string.replace("(Harlequin Kimani Romance)", "")
    s_string = s_string.replace("(Harlequin Romance)", "")
    s_string = s_string.replace("(Harlequin Superromance)", "")
    s_string = s_string.replace("(Historical Romance)", "")
    s_string = s_string.replace("(Paper Original)", "")
    s_string = s_string.replace("(Romance)", "")
    s_string = s_string.replace("(Short Story)", "")
    s_string = s_string.replace("(Siren Publishing Menage Amour)", "")
    s_string = s_string.replace("(Thorndike Press Large Print Basic Series)", "")
    s_string = s_string.replace("[En]", "")
    s_string = s_string.replace("**", "")
    s_string = s_string.replace("This Is an Advance Reader Copy Provided for Review Purposes Only. Not for Resale or Distribution", "")
    s_string = s_string.replace("This Is an Advance Reader Copy Provided for Review Purposes Only", "")
    s_string = s_string.replace("Advanced Reader's Copy Only. Not for Resale or Distribution", "")
    s_string = s_string.replace("Advanced Reader's Copy Only", "")
    s_string = s_string.replace("Advanced Reader's Copy", "")
    s_string = s_string.replace("*Retail Copy*", "")
    s_string = s_string.replace("BBW Billionaire Erotic Romance Novella", "")
    s_string = s_string.replace("BBW Romance -", "")
    s_string = s_string.replace("BBW Romance", "")
    s_string = s_string.replace("BDSM Erotic Romance", "")
    s_string = s_string.replace("BDSM", "")
    s_string = s_string.replace("Contemporary Romance", "")
    s_string = s_string.replace("Dodo Press", "")
    s_string = s_string.replace("Domination / Erotic Romance", "")
    s_string = s_string.replace("EBK.qxd", "")
    s_string = s_string.replace("Fantasy, Paranormal, Romance", "")
    s_string = s_string.replace("Harlequin Kimani Romance", "")
    s_string = s_string.replace("Harlequin Romance", "")
    s_string = s_string.replace("Harlequin Superromance", "")
    s_string = s_string.replace("Historical Romance", "")
    s_string = s_string.replace("Microsoft Word-", "")
    s_string = s_string.replace("Microsoft Word", "")
    s_string = s_string.replace("Paper Original", "")
    s_string = s_string.replace("Paperback", "")
    s_string = s_string.replace("Penguin Classics", "")
    s_string = s_string.replace("Retail Copy", "")
    s_string = s_string.replace("Romance / Romantic Suspense", "")
    #~ s_string = s_string.replace("Romance", "")  # also kills the Work Tag!
    s_string = s_string.replace("Short Story", "")
    s_string = s_string.replace("Spanish Edition", "")
    s_string = s_string.replace("Spanish-language edition", "")
    s_string = s_string.replace("Thorndike Press Large Print Basic Series", "")
    s_string = s_string.replace("Vintage Espanol", "")
    s_string = s_string.replace("With Bonus Material", "")
    s_string = s_string.replace("Woman Hollering Creek--", "")


    #----------------------------------------------------------------------------------------------------------------
    s_string = s_string.replace("(digital)", "")           #common cbz/cbr keywords in title
    s_string = s_string.replace("(Digital)", "")
    s_string = s_string.replace("(Minutemen-Midas)", "")
    s_string = s_string.replace("(minutemen-midas)", "")
    s_string = s_string.replace("(zone-empire)", "")
    s_string = s_string.replace("(Zone-Empire)", "")
    s_string = s_string.replace("(Minutemen-Faessla)", "")
    s_string = s_string.replace("(minutemen-faessla)", "")
    s_string = s_string.replace("(Minutemen-Spaztastic)", "")
    s_string = s_string.replace("(minutemen-spaztastic)", "")
    s_string = s_string.replace("(webrip)", "")
    s_string = s_string.replace("(Webrip)", "")
    s_string = s_string.replace("(GreenGiant-DCP)", "")
    s_string = s_string.replace("(greengiant-dcp)", "")
    s_string = s_string.replace("(Minutemen-PhD)", "")
    s_string = s_string.replace("(minutemen-phd)", "")
    s_string = s_string.replace("(2 covers)", "")
    s_string = s_string.replace("(2 Covers)", "")
    s_string = s_string.replace("All-New", "")
    s_string = s_string.replace("all-new", "")
    s_string = s_string.replace("(Digital Empire)", "")
    s_string = s_string.replace("(digital empire)", "")
    s_string = s_string.replace("(Zone-Empire)", "")
    s_string = s_string.replace("(The Last Kryptonian-DCP)", "")
    s_string = s_string.replace("(Ol' Joe-DCP)", "")
    s_string = s_string.replace("(Webrip-DCP)", "")
    s_string = s_string.replace("(ThatGuy-Empire)", "")
    s_string = s_string.replace("(Son of Ultron-Empire)", "")
    s_string = s_string.replace(" phuc ", "")
    s_string = s_string.replace("(- Nem -)", "")
    s_string = s_string.replace("(Dr. Greenthumb)", "")
    s_string = s_string.replace("(Minutemen-Mollylvr)", "")
    s_string = s_string.replace("(Mephisto-Empire)", "")
    s_string = s_string.replace("(Cypher 2.0-Empire)", "")
    s_string = s_string.replace("(OkC O M P U T O -Novus-HD)", "")
    s_string = s_string.replace("(BlackManta-Empire)", "")
    s_string = s_string.replace("(Minutemen-Acan)", "")
    s_string = s_string.replace("(Minutemen-FlynnLives)", "")
    s_string = s_string.replace("(Son of Ultron III-Empire)", "")
    s_string = s_string.replace("(ThatGuy-Empire)", "")
    s_string = s_string.replace("(AnHeroGold-Empire)", "")
    s_string = s_string.replace("(TLK-EMPIRE-HD)", "")
    s_string = s_string.replace("(Minutemen-WTF)", "")
    s_string = s_string.replace("(DR & Quinch-Empire)", "")
    s_string = s_string.replace("(Kileko-Empire)", "")
    s_string = s_string.replace("(BlurPixel-Empire)", "")
    s_string = s_string.replace("(Nahga-Empire)", "")
    s_string = s_string.replace("(Sooth&Talon-Novus-HD)", "")
    s_string = s_string.replace("(d'argh-Empire)", "")
    s_string = s_string.replace("(Vee-Empire)", "")
    s_string = s_string.replace("(AnPymGold-Empire)", "")
    s_string = s_string.replace("(Minutemen-Hawaiian Punch)", "")
    s_string = s_string.replace("(Minutemen-InnerDemons)", "")
    s_string = s_string.replace("(AnHeroGold-Empire)", "")
    s_string = s_string.replace("(Minutemen-Ghus)", "")
    s_string = s_string.replace("(Kileko-Empire)", "")
    s_string = s_string.replace("(UberSoldier-DCP)", "")
    s_string = s_string.replace("(TheDemiurge-Empire)", "")
    s_string = s_string.replace("(GreenManGroup-DCP)", "")
    s_string = s_string.replace("(FatNerd)", "")
    s_string = s_string.replace("(webrip-DCP)", "")
    s_string = s_string.replace("(Minutemen-Phantasm)", "")
    s_string = s_string.replace("(atomicmass77-DCP)", "")
    s_string = s_string.replace("(digital-Empire)", "")
    s_string = s_string.replace("(TheMaseThing-DCP)", "")
    s_string = s_string.replace("(three covers)", "")
    s_string = s_string.replace("(Jojo)", "")
    s_string = s_string.replace("(Harkonnen-DCP)", "")
    s_string = s_string.replace("(phillywill-Empire)", "")
    s_string = s_string.replace("(Eos-Empire)", "")
    s_string = s_string.replace("(TheArchivist-Empire)", "")
    s_string = s_string.replace("(Ookla-Empire)", "")
    s_string = s_string.replace("(The Magicians-Empire)", "")
    s_string = s_string.replace("(Pirate-Empire)", "")
    s_string = s_string.replace("(Mr Norrell-Empire)", "")
    s_string = s_string.replace("(Meganubis)", "")
    #----------------------------------------------------------------------------------------------------------------

    s_string = s_string.replace("[html]", "")
    s_string = s_string.replace("(html)", "")
    s_string = s_string.replace("html", "")

    s_string = s_string.replace("()", "")

    s_string = s_string.replace("«", "")
    s_string = s_string.replace("»", "")
    s_string = s_string.replace("‹", "")
    s_string = s_string.replace("›", "")
    s_string = s_string.replace("†", "")
    s_string = s_string.replace("‡", "")
    s_string = s_string.replace("§", "")
    s_string = s_string.replace("•", "")
    s_string = s_string.replace("¶", "")
    s_string = s_string.replace("®", "")
    s_string = s_string.replace("©", "")
    s_string = s_string.replace("°", "")

     #---------------
    s_string = s_string.replace("  ", " ", 20)
    s_string = s_string.strip()
    #---------------

    if s_string.count("#") > 0:               #version 3.6.50 due to Graphic Novels processing
        s_string = s_string.replace(".1 ",".0 ")
        s_string = s_string.replace(".2 ",".0 ")
        s_string = s_string.replace(".3 ",".0 ")
        s_string = s_string.replace(".4 ",".0 ")
        s_string = s_string.replace(".6 ",".0 ")
        s_string = s_string.replace(".7 ",".0 ")
        s_string = s_string.replace(".8 ",".0 ")
        s_string = s_string.replace(".9 ",".0 ")
        s_string = s_string.replace(".00","")

    #---------------
    #final cleanup
    s_string = s_string.replace("()","")
    s_string = s_string.replace("[]","")
    s_string = s_string.replace("  ", " ")
    s_string = s_string.strip()

    return s_string
# ---------------------------------------------------------------------------------------
# ---------------------------------------------------------------------------------------
# ---------------------------------------------------------------------------------------
#END OF booklevel_keywords.py
